"use strict";

document.addEventListener( 'DOMContentLoaded', () => {

    if ( document.querySelector( '.woocommerce-checkout-review-order' ) ) {
        document.querySelector( '.woocommerce-checkout-review-order' ).addEventListener( 'click', e => {
            if ( e.target.closest( '#ddwcwm-remove-wallet' ) ) {
				e.preventDefault();

				e.target.closest( '#ddwcwm-remove-wallet' ).disabled = true;

                fetch( ddwcwmFrontObj.ajaxUrl, {
                    method: "post",
                    headers: new Headers( {
                        "Content-Type": "application/x-www-form-urlencoded",
                        "Accept": "application/json"
                    } ),
                    body: "action=ddwcwm_remove_wallet_amount_from_session&ddwcwm_nonce=" + ddwcwmFrontObj.ajaxNonce,
                } )
                .then( response => response.ok ? response.json() : false ).then( response => {
                    if ( response.success ) {
						document.querySelector( 'body' ).dispatchEvent( new Event( 'update_checkout' ) );
                    }
                } );
            } else if ( e.target.closest( '#ddwcwm-use-wallet-button' ) ) {
				e.preventDefault();

				e.target.closest( '#ddwcwm-use-wallet-button' ).disabled = true;

				fetch( ddwcwmFrontObj.ajaxUrl, {
					method: "post",
					headers: new Headers( {
						"Content-Type": "application/x-www-form-urlencoded",
						"Accept": "application/json"
					} ),
					body: "action=ddwcwm_add_wallet_amount_in_session&ddwcwm_nonce=" + ddwcwmFrontObj.ajaxNonce,
				} )
				.then( response => response.ok ? response.json() : false ).then( response => {
					if ( response.success ) {
						document.querySelector( 'body' ).dispatchEvent( new Event( 'update_checkout' ) );
					}
				} );
            }
        } );
	}

	if ( document.querySelectorAll( '.ddwcwm-wallet-operations a' ) ) {
		document.querySelectorAll( '.ddwcwm-wallet-operations a' ).forEach( element => {
			element.addEventListener( 'click', e => {
				e.preventDefault();
				const operation = e.target.closest('a').getAttribute( 'data-operation' );
				if ( operation == 'send' ) {
					document.querySelector( '#ddwcwm-wallet-send-money-popup' ).classList.add( 'ddwcwm-popup-open' );
				} else if ( operation == 'request' ) {
					document.querySelector( '#ddwcwm-wallet-request-money-popup' ).classList.add( 'ddwcwm-popup-open' );
				} else if ( operation == 'withdraw' ) {
					document.querySelector( '#ddwcwm-wallet-withdraw-money-popup' ).classList.add( 'ddwcwm-popup-open' );
				} else if ( operation == 'refer' ) {
					document.querySelector( '#ddwcwm-wallet-refer-popup' ).classList.add( 'ddwcwm-popup-open' );
				}
			} );
		} );
	}

	const ddwcwmClosePopup = element => {
		const popupElement = element.closest( '.ddwcwm-wallet-operation-popup' );
		popupElement.classList.remove( 'ddwcwm-popup-open' );
		popupElement.querySelector( 'form' ).reset();
		const messageElement = popupElement.querySelector( 'form .ddwcwm-message' );
		messageElement.innerHTML = '';
		messageElement.classList.remove( 'woocommerce-error' );
		messageElement.classList.remove( 'woocommerce-message' );
	}

	if ( document.querySelectorAll( '.ddwcwm-close-popup' ) ) {
		document.querySelectorAll( '.ddwcwm-close-popup' ).forEach( element => {
			element.addEventListener( 'click', e => {
				ddwcwmClosePopup( e.target );
			} );
		} );
	}

	if ( document.querySelectorAll( '.ddwcwm-wallet-operation-popup' ) ) {
		document.querySelectorAll( '.ddwcwm-wallet-operation-popup' ).forEach( element => {
			element.addEventListener( 'click', e => {
				if ( e.target.classList.contains( 'ddwcwm-wallet-operation-popup' ) ) {
					ddwcwmClosePopup( e.target );
				}
			} );
		} );
	}

	const ddwcwmSendOTP = ( element, addSubmitListener = true ) => {
		const currentOperationPopupContentElement = element.closest( '.ddwcwm-wallet-operation-popup-content' );
		const verifyOTPForm = currentOperationPopupContentElement.querySelector( '#ddwcwm-verify-otp-form' );

		if ( verifyOTPForm ) {
			const formData = new FormData();

			formData.append( 'action', 'ddwcwm_sent_otp_to_user' );
			formData.append( 'ddwcwm_nonce', ddwcwmFrontObj.ajaxNonce );

			fetch( ddwcwmFrontObj.ajaxUrl, {
				method: "post",
				body  : formData
			} )
			.then( response => response.ok ? response.json() : false ).then( response => {

				const verifyOTPForm = currentOperationPopupContentElement.querySelector( '#ddwcwm-verify-otp-form' );

				const messageElement = verifyOTPForm.querySelector( '.ddwcwm-message' );
				messageElement.innerHTML = response.message;

				if ( response.success ) {
					element.style.display = 'none';
					verifyOTPForm.style.display = 'block';
					messageElement.classList.add( 'woocommerce-message' );
					messageElement.classList.remove( 'woocommerce-error' );

					localStorage.setItem( 'ddwcwmOtpEncoded', response.otp );
					localStorage.setItem( 'ddwcwmOtpSentTime', new Date().getTime() );

					const demoOTPElement = verifyOTPForm.querySelector( '.ddwcwm-demo-otp' );

					if ( demoOTPElement ) {
						demoOTPElement.innerHTML = ddwcwmFrontObj.i18n.demoOtp + ' - ' + atob( response.otp );
						demoOTPElement.classList.add( 'woocommerce-info' );
					}

					if ( addSubmitListener ) {
						verifyOTPForm.addEventListener( 'submit', e => {
							const sentOtpValue = atob( localStorage.getItem( 'ddwcwmOtpEncoded' ) );
							const otpSentTime  = localStorage.getItem( 'ddwcwmOtpSentTime' );

							e.preventDefault();
							const SubmitButton = verifyOTPForm.querySelector( '#ddwcwm-verify-otp-submit' );
							SubmitButton.setAttribute( 'disabled', 'disabled' );

							let otpValue = verifyOTPForm.querySelector( '#ddwcwm-otp' ).value;

							if ( otpValue ) {
								const currentTime = new Date().getTime();
								const difference = ( currentTime - otpSentTime ) / 1000;

								if ( sentOtpValue == otpValue ) {
									if ( ! ddwcwmFrontObj.ddwcwm_wallet.otp_expiry || difference <= ddwcwmFrontObj.ddwcwm_wallet.otp_expiry ) {
										currentOperationPopupContentElement.querySelector( '#ddwcwm-otp-verification-done' ).value = 'done';
										element.style.display = 'block';
										verifyOTPForm.style.display = 'none';
										element.dispatchEvent( new Event( 'submit' ) );
										SubmitButton.removeAttribute( 'disabled' );
									} else {
										messageElement.innerHTML = response.otpExpiredMessage;
										messageElement.classList.add( 'woocommerce-error' );
										SubmitButton.removeAttribute( 'disabled' );

										verifyOTPForm.querySelector( '.ddwcwm-resend-otp' ).addEventListener( 'click', e => {
											ddwcwmSendOTP( element, false );
										} );
									}
								} else {
									messageElement.innerHTML = response.inValidOtpMessage;
									messageElement.classList.add( 'woocommerce-error' );
									SubmitButton.removeAttribute( 'disabled' );
								}
							} else {
								alert( ddwcwmFrontObj.i18n.enterOtp );
								SubmitButton.removeAttribute( 'disabled' );
							}

						} );
					}

				} else {
					messageElement.classList.add( 'woocommerce-error' );
					messageElement.classList.remove( 'woocommerce-message' );
				}
			} );
		}
	}

	if ( document.querySelector( '#ddwcwm-send-money-form' ) ) {
		document.querySelector( '#ddwcwm-send-money-form' ).addEventListener( 'submit', e => {
			e.preventDefault();
			const otpVerificationDoneElement = e.target.closest( '.ddwcwm-wallet-operation-popup-content' ).querySelector( '#ddwcwm-otp-verification-done' );
			const SubmitButton = document.querySelector( '#ddwcwm-send-money-submit' );
			SubmitButton.setAttribute( 'disabled', 'disabled' );
			if ( ! otpVerificationDoneElement.value ) {
				ddwcwmSendOTP( e.target );
			} else {
				const formData = new FormData( e.target );

				formData.append( 'action', 'ddwcwm_send_money_to_user' );
				formData.append( 'ddwcwm_nonce', ddwcwmFrontObj.ajaxNonce );

				fetch( ddwcwmFrontObj.ajaxUrl, {
					method: "post",
					body: formData
				} )
				.then( response => response.ok ? response.json() : false ).then( response => {
					SubmitButton.removeAttribute( 'disabled' );

					const messageElement = e.target.querySelector( '.ddwcwm-message' );
					messageElement.innerHTML = response.message;

					if ( response.success ) {
						messageElement.classList.add( 'woocommerce-message' );
						messageElement.classList.remove( 'woocommerce-error' );
						otpVerificationDoneElement.value = '';
						e.target.reset();
					} else {
						messageElement.classList.add( 'woocommerce-error' );
						messageElement.classList.remove( 'woocommerce-message' );
					}
				} );
			}

		} );
	}

	if ( document.querySelector( '#ddwcwm-request-money-form' ) ) {
		document.querySelector( '#ddwcwm-request-money-form' ).addEventListener( 'submit', e => {
			e.preventDefault();
			const otpVerificationDoneElement = e.target.closest( '.ddwcwm-wallet-operation-popup-content' ).querySelector( '#ddwcwm-otp-verification-done' );
			const SubmitButton = document.querySelector( '#ddwcwm-request-money-submit' );
			SubmitButton.setAttribute( 'disabled', 'disabled' );
			if ( ! otpVerificationDoneElement.value ) {
				ddwcwmSendOTP( e.target );
			} else {
				const formData = new FormData( e.target );

				formData.append( 'action', 'ddwcwm_request_money_from_user' );
				formData.append( 'ddwcwm_nonce', ddwcwmFrontObj.ajaxNonce );

				fetch( ddwcwmFrontObj.ajaxUrl, {
					method: "post",
					body: formData
				} )
				.then( response => response.ok ? response.json() : false ).then( response => {

					SubmitButton.removeAttribute( 'disabled' );

					const messageElement = e.target.querySelector( '.ddwcwm-message' );
					messageElement.innerHTML = response.message;

					if ( response.success ) {
						messageElement.classList.add( 'woocommerce-message' );
						messageElement.classList.remove( 'woocommerce-error' );
						otpVerificationDoneElement.value = '';
						e.target.reset();
					} else {
						messageElement.classList.add( 'woocommerce-error' );
						messageElement.classList.remove( 'woocommerce-message' );
					}

				} );
			}
		} );
	}

	if ( document.querySelector( '#ddwcwm-withdraw-money-form' ) ) {
		document.querySelector( '#ddwcwm-withdraw-money-form' ).addEventListener( 'submit', e => {
			e.preventDefault();
			const otpVerificationDoneElement = e.target.closest( '.ddwcwm-wallet-operation-popup-content' ).querySelector( '#ddwcwm-otp-verification-done' );
			const SubmitButton = document.querySelector( '#ddwcwm-withdraw-money-submit' );
			SubmitButton.setAttribute( 'disabled', 'disabled' );
			if ( ! otpVerificationDoneElement.value ) {
				ddwcwmSendOTP( e.target );
			} else {
				const formData = new FormData( e.target );

				formData.append( 'action', 'ddwcwm_withdraw_money_from_user' );
				formData.append( 'ddwcwm_nonce', ddwcwmFrontObj.ajaxNonce );

				fetch( ddwcwmFrontObj.ajaxUrl, {
					method: "post",
					body: formData
				} )
				.then( response => response.ok ? response.json() : false ).then( response => {

					SubmitButton.removeAttribute( 'disabled' );

					const messageElement = e.target.querySelector( '.ddwcwm-message' );
					messageElement.innerHTML = response.message;

					if ( response.success ) {
						messageElement.classList.add( 'woocommerce-message' );
						messageElement.classList.remove( 'woocommerce-error' );
						otpVerificationDoneElement.value = '';
						e.target.reset();
					} else {
						messageElement.classList.add( 'woocommerce-error' );
						messageElement.classList.remove( 'woocommerce-message' );
					}

				} );
			}
		} );
	}

	if ( document.querySelector( '#ddwcwm-wallet-refer-form' ) ) {
		document.querySelector( '#ddwcwm-wallet-refer-form' ).addEventListener( 'submit', e => {
			e.preventDefault();
			const SubmitButton = document.querySelector( '#ddwcwm-wallet-refer-submit' );
			SubmitButton.setAttribute( 'disabled', 'disabled' );
			const formData = new FormData( e.target );

			formData.append( 'action', 'ddwcwm_wallet_refer_to_user' );
			formData.append( 'ddwcwm_nonce', ddwcwmFrontObj.ajaxNonce );

			fetch( ddwcwmFrontObj.ajaxUrl, {
				method: "post",
				body  : formData
			} )
			.then( response => response.ok ? response.json() : false ).then( response => {

				SubmitButton.removeAttribute( 'disabled' );

				const messageElement = e.target.querySelector( '.ddwcwm-message' );
				messageElement.innerHTML = response.message;

				if ( response.success ) {
					messageElement.classList.add( 'woocommerce-message' );
					messageElement.classList.remove( 'woocommerce-error' );
					e.target.reset();
				} else {
					messageElement.classList.add( 'woocommerce-error' );
					messageElement.classList.remove( 'woocommerce-message' );
				}

			} );
		} );
	}

} );