/*global ajaxurl, ddwcwm_users_import_params */
;(function ( $, window ) {

	/**
	 * usersImportForm handles the import process.
	 */
	var usersImportForm = function( $form ) {
		this.$form           = $form;
		this.xhr             = false;
		this.mapping         = ddwcwm_users_import_params.mapping;
		this.position        = 0;
		this.file            = ddwcwm_users_import_params.file;
		this.update_existing = ddwcwm_users_import_params.update_existing;
		this.delimiter       = ddwcwm_users_import_params.delimiter;
		this.security        = ddwcwm_users_import_params.import_nonce;

		// Number of import successes/failures.
		this.imported = 0;
		this.failed   = 0;
		this.updated  = 0;
		this.skipped  = 0;

		// Initial state.
		this.$form.find('.woocommerce-importer-progress').val( 0 );

		this.run_import = this.run_import.bind( this );

		// Start importing.
		this.run_import();
	};

	/**
	 * Run the import in batches until finished.
	 */
	usersImportForm.prototype.run_import = function() {
		var $this = this;

		$.ajax( {
			type: 'POST',
			url: ajaxurl,
			data: {
				action          : 'ddwcwm_do_ajax_users_import',
				position        : $this.position,
				mapping         : $this.mapping,
				file            : $this.file,
				update_existing : $this.update_existing,
				delimiter       : $this.delimiter,
				security        : $this.security
			},
			dataType: 'json',
			success: function( response ) {
				if ( response.success ) {
					$this.position  = response.data.position;
					$this.imported += response.data.imported;
					$this.failed   += response.data.failed;
					$this.skipped  += response.data.skipped;
					$this.$form.find('.woocommerce-importer-progress').val( response.data.percentage );

					if ( 'done' === response.data.position ) {
						window.location = response.data.url + '&users-imported=' + parseInt( $this.imported, 10 ) + '&users-failed=' + parseInt( $this.failed, 10 ) + '&users-skipped=' + parseInt( $this.skipped, 10 );
					} else {
						$this.run_import();
					}
				}
			}
		} ).fail( function( response ) {
			window.console.log( response );
		} );
	};

	/**
	 * Function to call usersImportForm on jQuery selector.
	 */
	$.fn.ddwcwm_user_importer = function() {
		new usersImportForm( this );
		return this;
	};

	$( '.woocommerce-importer' ).ddwcwm_user_importer();

})( jQuery, window );
