<?php
/**
 * Admin hooks class
 *
 * @package WooCommerce Wallet Management
 * @version 1.0.0
 */

namespace DDWCWalletManagement\Includes\Admin;

defined( 'ABSPATH' ) || exit();

if ( ! class_exists( 'DDWCWM_Admin_Hooks' ) ) {
	/**
	 * Admin hooks class
	 */
	class DDWCWM_Admin_Hooks extends DDWCWM_Admin_Functions {
		/**
		 * Construct
		 */
		public function __construct() {
			add_action( 'admin_init', [ $this, 'ddwcwm_register_settings' ] );
			add_action( 'admin_menu', [ $this, 'ddwcwm_add_menu_at_admin_end' ] );
			add_action( 'admin_enqueue_scripts', [ $this, 'ddwcwm_admin_scripts' ] );
			add_filter( 'woocommerce_screen_ids', [ $this, 'ddwcwm_set_wc_screen_ids' ] );

			add_filter( 'set-screen-option', [ $this, 'ddwcwm_set_options' ], 10, 3 );

			add_action( 'woocommerce_order_status_cancelled', [ $this, 'ddwcwm_handle_wallet_on_order_cancelled' ] );

			add_action( 'woocommerce_order_refunded', [ $this, 'ddwcwm_handle_wallet_on_order_fully_refunded' ] );
		}
	}
}
