<?php
/**
 * Common hooks class
 *
 * @package WooCommerce Wallet Management
 * @version 1.0.0
 */

namespace DDWCWalletManagement\Includes\Common;

defined( 'ABSPATH' ) || exit();

if ( ! class_exists( 'DDWCWM_Common_Hooks' ) ) {

	/**
	 * Common hooks class
	 */
	class DDWCWM_Common_Hooks extends DDWCWM_Common_Functions {

		/**
		 * Construct
		 */
		public function __construct() {
			add_action( 'init', [ $this, 'ddwcwm_add_endpoints' ] );

			add_filter( 'woocommerce_payment_gateways', [ $this, 'ddwcwm_add_payment_gateway' ] );

			add_filter( 'woocommerce_email_classes', [ $this, 'ddwcwm_add_new_email_notification' ] );
			add_filter( 'woocommerce_email_actions', [ $this, 'ddwcwm_add_notification_actions' ] );

			add_filter( 'ddwcuws_modify_whatsapp_message_for_other_text', [ $this, 'ddwcwm_add_whatsapp_automation' ], 10, 2 );

			add_filter( 'ddwcuws_remove_payment_gateway_for_whatsapp_purchase', [ $this, 'ddwcwm_handle_removing_wallet_for_whatsapp_purchase' ], 10, 4 );
        }
	}
}
