<?php
/**
 * Wallet Notification email
 *
 * @package WooCommerce Wallet Management
 * @version 1.0.0
 */

defined( 'ABSPATH' ) || exit();

echo '= ' . esc_html( $email_heading ) . " =\n\n";

/* translators: %s Customer email */

if ( ! empty( $display_name ) ) {
    /* translators: %s Display name */
    echo sprintf( esc_html__( 'Hi %s,', 'ddwc-wallet-management' ), esc_html( $display_name ) ) . "\n\n";
} else {
    /* translators: %s Customer email */
    echo sprintf( esc_html__( 'Hi %s,', 'ddwc-wallet-management' ), esc_html( $customer_email ) ) . "\n\n";
}

if ( ! empty( $email_message ) ) {
    foreach( $email_message as $key => $message ) {
        echo wp_kses_post( $message ) . "\n\n";
    }
}

/**
 * Show user-defined additional content - this is set in each email's settings.
 */
if ( $additional_content ) {
	echo esc_html( wp_strip_all_tags( wptexturize( $additional_content ) ) );
	echo "\n\n";
}

echo esc_html__( 'We are looking forward to seeing you again.', 'ddwc-wallet-management' ) . "\n\n";

echo "\n=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=\n\n";

echo apply_filters( 'woocommerce_email_footer_text', get_option( 'woocommerce_email_footer_text' ) ); // phpcs:ignore WordPress.XSS.EscapeOutput.OutputNotEscaped