<?php
/**
 * Wallet Balance Layout Shortcode
 *
 * @package WooCommerce Wallet Management
 * @version 1.0.0
 */

use DDWCWalletManagement\Helper\Users\DDWCWM_Users_Helper;

defined( 'ABSPATH' ) || exit();

$user_helper       = new DDWCWM_Users_Helper();
$wallet_balance    = $user_helper->ddwcwm_get_user_wallet_balance();
$today_transaction = $user_helper->ddwcwm_get_user_today_transaction_amount();

?>
<div class="ddwcwm-wallet-balance-wrapper">
    <img src="<?php echo esc_url( DDWCWM_PLUGIN_URL . 'assets/images/wallet-main.png' ); ?>" width="80" />

    <p><?php esc_html_e( 'Available Balance', 'ddwc-wallet-management' ); ?></p>
    <span class="ddwcwm-wallet-balance"><?php echo wc_price( apply_filters( 'ddwcwm_modify_amount_to_multi_currency', $wallet_balance ) ); ?></span>

    <p class="ddwcwm-wallet-today-balance">
        <span><?php esc_html_e( 'Today', 'ddwc-wallet-management' ); ?></span>
        <span class="ddwcwm-credit">+<?php echo wc_price( apply_filters( 'ddwcwm_modify_amount_to_multi_currency', $today_transaction[ 'credit' ] ) ); ?></span>
        <span class="ddwcwm-debit">-<?php echo wc_price( apply_filters( 'ddwcwm_modify_amount_to_multi_currency', $today_transaction[ 'debit' ] ) ); ?></span>
    </p>
</div>